
#include <stdio.h>
#include <string.h>

#include "Image.hh"

#define ABS(a) (a)>0?(a):(-a)
#define MAX(a,b) (a)>(b)?(a):(b)
#define MIN(a,b) (a)<(b)?(a):(b) 


int ChangeBord(int val) {BORD=val;return 1;}


/**************************************************************/
/******************** Operateurs booleens *********************/
/**************************************************************/

BOOL NON(BOOL i) {return 255-i;} 

BOOL ET(BOOL i,BOOL j){
  if (i<j) return i; else return j;}

BOOL OU(BOOL i,BOOL j){
  if (i>j) return i; else return j;}
      
BOOL XOU(BOOL i,BOOL j) {if (i<j) return(j-i); else return (i-j);}

/************************************************************/
/*     classe Info           -          Implementation      */
/************************************************************/

template <class T> Info<T>::Info(){ pix = NULL; S=0; }
template <class T> Info <T>::Info(int taille) {
            pix = new T[taille];
            S = taille;}
template <class T> Info<T>::Info(int t,T* im) {
            pix = new T[t];
            S = t;
	    // for (int i=0;i<S;i++) pix[i] = im[i];
            memcpy(pix,im,S*sizeof(T));}
template <class T> Info<T>::Info(const Info<T>& ii){ 
     S = ii.S;
     pix = ii.pix;
      }
template <class T> Info<T>::~Info() { if (pix) delete[] pix;}
  
template <class T> Info<T>&  Info<T>::operator=(const Info<T>& ii){
   int i;
    if (pix != ii.pix){
      if (pix) delete[] pix;
      pix = new T[ii.S];
      S = ii.S;
      memcpy(pix,ii.pix,S*sizeof(T));
      //  for (i=0;i<S;i++) pix[i] = ii.pix[i];
        }
    return *this;} 
template <class T> T Info<T>::operator[](const int& i) const{
    return pix[i];}
template <class T> T* Info<T>::ref() const{
    return pix;}
template <class T> void Info<T>::Ecrit_info(const int& i,const T& z) {
    pix[i] = z; }
 
 
/************************************************************/
/* structure Vecteur        -     Implementation            */
/************************************************************/


  Vecteur::Vecteur() { x = y = 0;}
  Vecteur::Vecteur(int i, int j) { x = i; y = j;}
  Vecteur::Vecteur(const Vecteur& v) {x=v.x;y=v.y;}
  Vecteur::~Vecteur() {}

  Vecteur& Vecteur::operator=(const Vecteur& v) {
    x = v.x; y = v.y; return *this;}
  Vecteur Vecteur::operator+(const Vecteur& v) {
    return Vecteur(x + v.x,y + v.y);}
  Vecteur& Vecteur::operator+=(const Vecteur& v) {
    x += v.x; y += v.y; 
    return *this;}
  int Vecteur::operator*(const Vecteur& v) {
    return x*v.x + y*v.y;}
  Vecteur Vecteur::operator-(){
    return Vecteur(-x,-y); }
  Vecteur Vecteur::rot90() {
    return Vecteur(-y,x);}
  Vecteur Vecteur::rot270() {
    return Vecteur(y,-x);}
  int Vecteur::operator==(const Vecteur& t)
    {
      return ((x == t.x) && (y == t.y));
    }


/************************************************************/
/* classe Noyau          -        Implementation            */
/************************************************************/
 
 
  Noyau::Noyau() {}  
  Noyau::~Noyau() {}
 
Noyau& Noyau::operator= (const Noyau& k)
{
  debx=k.debx;deby=k.deby;finx=k.finx;finy=k.finy;
  int larg=(finx-debx);
  int haut=(finy-deby);
  if (val != k.val)
    memcpy(val,k.val,larg*haut*sizeof(int));
  return *this; }
 
int Noyau::KX0(){ return debx;}
 
int Noyau::KX1(){ return finx;}
 
int Noyau::KY0(){ return deby;}     

int Noyau::KY1(){ return finy;}
 
Noyau& Noyau::Noyau_efface ()
   {
   for (int i=debx;i<=finx;i++)
     for (int j=deby;j<=finy;j++)
       val[i][j]=0;
   return *this;
   }

Noyau& Noyau::Noyau_setmasque(int tab[9][9])
{
int first=1;
 for (int i=0;i<9;i++)
     for (int j=0;j<9;j++) {
          if (tab[i][j]) {
            if (first) {
                first=0;
                debx=i-4;deby=j-4;
                finx=i-4;finy=j-4;
                } else {
                finx=i-4;finy=j-4;
                }
               }
             val[i-4][j-4]=tab[i][j];
             }       
return *this;
}

Noyau Noyau::Noyau_transpose ()
{
  Noyau q;
  q.debx=-finx;q.finx=-debx;
  q.deby=-finy;q.finy=-deby;
  for (int i=q.debx;i<=q.finx;i++)
    for (int j=q.deby;j<=q.finy;j++)
      q.val[i][j]=val[-i][-j];
   return q;
   }   
         
Noyau Noyau::operator+ (const Noyau& ker)
   {
   Noyau q;
   for (int i=debx;i<=finx;i++)
     for (int j=deby;j<=finy;j++)
       q.val[i][j] = ker.val[i][j]+val[i][j];
   return q;
    }
 
Noyau Noyau::operator* (const int x)
  {
    Noyau q;
    for (int i=debx;i<=finx;i++)
      for (int j=deby;j<=finy;j++)
        q.val[i][j] = x*val[i][j];
      return q;
    }       
        
/************************************************************/
/* classe FIFO           -        Implementation            */
/************************************************************/

FIFO::FIFO() {}

FIFO::FIFO(int taille)
{listx = new int[taille];
 listy = new int[taille];
 first = 0; last = 0;
 size = taille;}
 
FIFO::~FIFO()
{
  if (listx) delete[] listx;
  if (listy) delete[] listy;
  }

FIFO& FIFO::operator=(const FIFO& ff) {
  size = ff.size;
  last = ff.last;
  first = ff.first;
  memcpy(listx,ff.listx,size*sizeof(int));
  memcpy(listy,ff.listy,size*sizeof(int));
  return *this;
}

FIFO& FIFO::FIFO_delete () {
  first = 0; last = 0;
  return *this;
}

FIFO& FIFO::FIFO_alloc(int taille)
{listx = new int[taille];
 listy = new int[taille];
 first = 0; last = 0;
 size = taille;}

FIFO& FIFO::FIFO_free()
{if (listx) delete[] listx;
 if (listy) delete[] listy;}

FIFO& FIFO::FIFO_add (int x,int y) {
listx[last]=x;listy[last]=y;
last++;
if (last == size) this->FIFO_reinit();
return *this;
}

FIFO& FIFO::FIFO_reinit () {
for (int i=first;i<=last;i++) {
  listx[i-first]=listx[i];listy[i-first]=listy[i];}
last -=first;
first = 0;
return *this;
}

void FIFO::FIFO_get(int& x,int& y) {
x = listx[first];
y = listy[first++];}

int FIFO::FIFO_empty() const {
return (first==last);}

/************************************************************/
/* classe Image           -        Implementation            */
/************************************************************/


Image<int>::Image() {}
Image<int>::Image(const int& i,const int& j) : I(i*j)
{ W = i; L = j; }
Image<int>::Image(const Image<int>& pp)
    {W = pp.W; 
     L = pp.L;
     I = pp.I;
     }
Image<int>::~Image() {}
  
Image<int>& Image<int>::operator= (const Image<int>& p)
    {W=p.W; L=p.L; I= p.I;
    return *this; }

int* Image<int>::PI(){ return I.ref();}

int Image<int>::PW(){ return W;}

int Image<int>::PL(){ return L;}

int Image<int>::X(int i,int j) const {
  switch(BORD) {
  case 0 : {
    if ((i<0)||(i>=W)||(j<0)||(j>=L)) return 0;
    else return I[j * W + i];
    break;
  }
  case 1 : {
    if (i < 0) i = 0;
    else if (i >= W) i = W-1;
    if (j < 0) j = 0;
    else if (j >= L) j = L-1;
    return I[j * W + i];
    break;
  }
  case 2 : {
    if (i < 0) i = W+i;
    else if (i >= W) i = i-W;
    if (j < 0) j = L+j;
    else if (j >= L) j = j-L;
    return I[j * W + i];
    break;
  }                        
}
}  

Image<int> Image<int>::Image_translat(const Vecteur& v) const {

  Image<int> q(W,L);
  for (int j=0;j<q.L;j++)
    for (int i=0;i < q.W; i++)
      q.I.Ecrit_info(j * W + i,X(i-v.x,j-v.y));
  return q; 
}

Image<int> Image<int>::Nord() const
{ return Image_translat(Vecteur(0,1));}

Image<int> Image<int>::Sud() const
{ return Image_translat(Vecteur(0,-1));}

Image<int> Image<int>::Est() const
{ return Image_translat(Vecteur(-1,0));}

Image<int> Image<int>::Ouest() const
{ return Image_translat(Vecteur(1,0));}

Image<int> Image<int>::NE() const
{ return Image_translat(Vecteur(-1,1));}

Image<int> Image<int>::SE() const
{ return Image_translat(Vecteur(-1,-1));}

Image<int> Image<int>::NW() const
{ return Image_translat(Vecteur(1,1));}

Image<int> Image<int>::SW() const
{ return Image_translat(Vecteur(1,-1));}

int* Image<int>::Image_hist ()
{
  return 0;
        } 

Image<int>& Image<int>::Image_efface () 
   {
   for (int i=0;i<W*L;i++) I.Ecrit_info(i,0);
   return *this;
   }

Image<int> Image<int>::operator+ (const Image<int>& p)
{
  Image<int> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) 
      q.I.Ecrit_info(j * W + i,p.X(i,j)+X(i,j)); 
  return q;
}

Image<BOOL> Image<BOOL>::operator& (const Image<BOOL>& p) const
   {
     int index=0;
     int value;
   Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++){
      if (I[index]<p.I[index]) value=I[index]; else value=p.I[index];
      q.I.Ecrit_info(index++,value);
    } 
  return q;
   }

Image<BOOL> Image<BOOL>::operator| (const Image<BOOL>& p) const
{
  int index=0;
  int value;
  Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) { 
      if (I[index]>p.I[index]) value=I[index]; else value=p.I[index];
      q.I.Ecrit_info(index++,value);
    } 
  return q;
}

Image<BOOL> Image<BOOL>::operator! () const
{
  int index=0;
  Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) { 
      q.I.Ecrit_info(index,255-I[index]);
      index++;
    }
  return q;
}

Image<BOOL> Image<BOOL>::operator^ (const Image<BOOL>& p) const
{
  int index=0;
  int value;
  Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) {
      if (I[index]>p.I[index]) value=I[index]-p.I[index]; else value=p.I[index]-I[index];
      q.I.Ecrit_info(index++,value);
    }
  return q;
}

Image<BOOL> Image<BOOL>::operator== (const Image<BOOL>& p) const
{
  int index;
  Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) { 
      index = j * W + i;
      q.I.Ecrit_info(index,NON(XOU(I[index],p.I[index])));
    }
  return q;
}

Image<BOOL> Image<BOOL>::operator- (const Image<BOOL>& p) const
{
  int index;
  Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) {
      index = j * W + i;
      q.I.Ecrit_info(index,ET(I[index],NON(p.I[index])));
    }
  return q;
}

Image<BOOL> Image<BOOL>::operator<= (const Image<BOOL>& p) const
{
  int index;
  Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) {
      index = j * W + i;
      q.I.Ecrit_info(index,OU(NON(I[index]),p.I[index]));
    }     
  return q;
}

Image<BOOL> Image<BOOL>::operator>= (const Image<BOOL>& p) const
{
  int index;
  Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) {
      index = j * W + i;
      q.I.Ecrit_info(index,OU(I[index],NON(p.I[index]))); 
    } 
  return q;
}

Image<BOOL> Image<int>::Image_seuil (const int s)
{
  int index;
  Image<BOOL> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) {
      index = j * W + i;
      q.I.Ecrit_info(index,255*(I[index] >= s));
    }
  return q;
}

Image<int> Image<int>::Image_diff(const Image<int>& p)
{
  int index=0;
  int value;
  Image<int> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) {
      value = 127 + I[index] - p.I[index];
      if (value<0) value=0; else if (value>255) value=255;
      q.I.Ecrit_info(index++,value);
    }  
  return q;
}

Image<int> Image<int>::Image_superpose(const Image<BOOL>& p,const int nb,const int coul)
{
  int index;
  Image<int> q(W,L);
  for (int j=0;j<L;j++)
    for (int i=0;i<W;i++) {
      index = j * W + i;
      if (p.I[index] == nb)
	q.I.Ecrit_info(index,500 + coul);
      else q.I.Ecrit_info(index,I[index]);
    }  
  return q;
}

int Image<int>::Imagetopgm (char *nom) const
{
	FILE *fp;

        if ((fp=fopen(nom,"w"))==NULL) {
                perror("fopen\n");
                return -1; 
        };
        fprintf(fp,"P5\n");
        fprintf(fp,"# CREATOR : God\n");
        fprintf(fp,"%d %d\n%d\n",W,L,255);
        for (int i=0;i<W*L;i++) fprintf(fp,"%c",I[i]);
        fclose(fp);
	return 0;
}

int Image<int>::Image_compte_pixel () const
  {
    int index;
    int compt = 0;
    for (int j=0;j<L;j++)
      for (int i=0;i<W;i++) {
	index = j * W + i;
	if (I[index] != 0) compt++;
      }
    return compt;
  } 
